//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "MyOpRx1.h"
#include "MyOpRx2.h"
#include "MyOpRx3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm3 *Form3;
bool need_reconnect;
//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm3::CheckBox1Click(TObject *Sender)
{
 try{
  if(CheckBox1->Checked){
     ClientSocket1->Open();
                        }
  else {ClientSocket1->Close();}
  }catch(...){}
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Error(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
 StatusBar1->SimpleText="Socket Error: "+AnsiString(ErrorCode);
 ErrorCode=0;
 need_reconnect=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Connect(TObject *Sender,
      TCustomWinSocket *Socket)
{
  StatusBar1->SimpleText="Connect to "+Socket->RemoteAddress;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Connecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
 StatusBar1->SimpleText="Connecting to "+ ClientSocket1->Address;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::ClientSocket1Disconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
 StatusBar1->SimpleText="Disconnect";
}
//---------------------------------------------------------------------------
void __fastcall TForm3::FormClose(TObject *Sender, TCloseAction &Action)
{
  Form1->OperaChatSpots1->Checked=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::FormCreate(TObject *Sender)
{
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
  ClientSocket1->Address=ini->ReadString("OPERA_CHAT","ADDRESS","144.76.158.174");
  ini->WriteString("OPERA_CHAT","ADDRESS",ClientSocket1->Address);
  ClientSocket1->Port =ini->ReadInteger("OPERA_CHAT","PORT",8000);
  ini->WriteInteger("OPERA_CHAT","PORT",ClientSocket1->Port);
  DataBaseExecStr=ini->ReadString("OPERA_DATABASE","EXEC_STRING","send_spot_to_database.bat");
  ini->WriteString("OPERA_DATABASE","EXEC_STRING",DataBaseExecStr);

  CheckBox1->Checked=ini->ReadBool("OPERA_CHAT","ACTIVE",true);
  ini->WriteBool("OPERA_CHAT","ACTIVE",Form3->CheckBox1->Checked);
  mycall=ini->ReadString("OP-32","MYCALL", "");
  myqth=ini->ReadString("OP-32","MYQTH", "");
  myname=ini->ReadString("OP-32","MYNAME", "");
  ini->WriteString("OP-32","MYNAME",myname);
  mycity=ini->ReadString("OP-32","MYCITY", "");
  ini->WriteString("OP-32","MYCITY",mycity);
  myant=ini->ReadString("OP-32","MYANT", "");
  ini->WriteString("OP-32","MYANT",myant);
  reverse_output=ini->ReadBool("OP-32","REVERSE_OUTPUT",true);
  LogFileName=ini->ReadString("OPERA_CHAT","LOG_FILE_NAME","opera_log.txt");
  ini->WriteString("OPERA_CHAT","LOG_FILE_NAME",LogFileName);
  SaveOperaSpotstologfile1->Checked=ini->ReadBool("OPERA_CHAT","LOG_ENABLE",true);
  ini->WriteBool("OPERA_CHAT","LOG_ENABLE",SaveOperaSpotstologfile1->Checked);
  bool b=ini->ReadBool("PSKREPORTER","UPLOAD_SPOT",true);
  if(b) CheckBox2->Enabled=true; else CheckBox2->Enabled=false;
 delete ini;

 time_t t=time(NULL);
     struct tm *t_cur;
      t_cur=gmtime(&t);

 sdate.sprintf("*********** %02u/%02u/%04u ***********",t_cur->tm_mday,t_cur->tm_mon+1,t_cur->tm_year+1900);
 sdate_old=sdate;
 RichEdit1->Lines->Insert(0,sdate);
 int FoundAt=RichEdit1->FindText(sdate,0,RichEdit1->Text.Length(),TSearchTypes()<< stMatchCase);
 RichEdit1->SelStart=FoundAt; RichEdit1->SelLength=sdate.Length();
 RichEdit1->SelAttributes->Color=clFuchsia;
 RichEdit1->SelStart=0; RichEdit1->SelLength=0;
 Form3->DoubleBuffered=true;
 WORD wVersionRequested;
 WSADATA wsaData;
 int err;
 wVersionRequested = MAKEWORD( 2, 0 );
 err = WSAStartup( wVersionRequested, &wsaData );
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Button1Click(TObject *Sender)
{
    AnsiString Msg;
    Edit1->Text.Trim();
    Msg="CHAT OPERA 136.0#"+Edit1->Text+"#"+Edit2->Text+"\n";

    try{
     if(!ClientSocket1->Active || need_reconnect)
     {
      ClientSocket1->Open();
      //ClientSocket1->Socket->SendText(mycall+"\n");
      CheckBox1->Checked=true;
     }
     if(ClientSocket1->Active) ClientSocket1->Socket->SendText("JOIN OPERA\n");
     if(ClientSocket1->Active) ClientSocket1->Socket->SendText(Msg);
     need_reconnect=false;
    }catch(...){need_reconnect=true;}

    if(!ClientSocket1->Active || need_reconnect) return;
    Edit2->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Button2Click(TObject *Sender)
{
    AnsiString Msg;
    Msg="CHAT OPERA 136.0#ALL#"+Edit2->Text+"\n";
    Edit2->Text="";
     try{
     if(!ClientSocket1->Active || need_reconnect)
     {
      ClientSocket1->Open();
      //ClientSocket1->Socket->SendText(mycall+"\n");
      CheckBox1->Checked=true;
     }
     if(ClientSocket1->Active)ClientSocket1->Socket->SendText("JOIN OPERA\n");
     if(ClientSocket1->Active)ClientSocket1->Socket->SendText(Msg);
     need_reconnect=false;
    }catch(...){need_reconnect=true;}
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Timer1Timer(TObject *Sender)
{
 //     
 time_t t=time(NULL);
 struct tm *t_cur;
 t_cur=gmtime(&t);
 sdate.sprintf("*********** %02u/%02u/%04u ***********",t_cur->tm_mday,t_cur->tm_mon+1,t_cur->tm_year+1900);
 if(sdate!=sdate_old)
 {
  sdate_old=sdate;
  RichEdit1->Lines->Insert(0,sdate);
  int FoundAt=RichEdit1->FindText(sdate,0,RichEdit1->Text.Length(),TSearchTypes()<< stMatchCase);
  RichEdit1->SelStart=FoundAt; RichEdit1->SelLength=sdate.Length();
  RichEdit1->SelAttributes->Color=clFuchsia;
  RichEdit1->SelStart=0; RichEdit1->SelLength=0;
 }
 ///
 if(CheckBox1->Checked)
 {
   try{
    if(!ClientSocket1->Active || need_reconnect)
    {
     ClientSocket1->Close();
     Sleep(500);
     ClientSocket1->Open();
     need_reconnect=false;
    }
   }catch(...){need_reconnect=true;}
 }
 //  
  if(CheckBox2->Checked)
 {
  try{
    if(!ClientSocket1->Active || need_reconnect)
    { ClientSocket1->Open();
    }
   if(ClientSocket1->Active && Memo1->Lines->Count>0)
   {ClientSocket1->Socket->SendText(Memo1->Lines->Text);
    Memo1->Lines->Text="";
   }
    //   
   if(Memo2->Lines->Count>0)
   { AnsiString runstr=DataBaseExecStr + " " + Memo2->Lines->Text;
     int result=WinExec(runstr.c_str(),SW_SHOWMINNOACTIVE);
     if(result>31){StatusBar1->SimpleText="Spot --> DB";
     Memo2->Lines->Text=""; }
   }
   need_reconnect=false;
  }catch(...){need_reconnect=true;}
 }
 time_t tt=time(NULL);
 if(tt-tnotsend>300)
 {Memo1->Lines->Text="";Memo2->Lines->Text="";}

}
//---------------------------------------------------------------------------

void __fastcall TForm3::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
 AnsiString s;
 try{
   s=Socket->ReceiveText();
 }catch(...){}
 if(s==NULL || s=="")return;
 s=s.Trim();
 StatusBar1->SimpleText=s;
 if(s.Pos("LOGIN:")>0 || s.Pos("login:")>0)
 {ClientSocket1->Socket->SendText(mycall+"\n");
  ClientSocket1->Socket->SendText("JOIN OPERA\n");
  ClientSocket1->Socket->SendText("set/qra "+myqth+"\n");
  StatusBar1->SimpleText="login";
 }

  int spos=1;  int slength=s.Length();
  while(spos<slength)
  {AnsiString s1;
   bool delimeterfound=false;
   for(int i=spos; i<=slength; i++)
     if(s.IsDelimiter("\n\r\a\x7\x0",i))
     {s1=s.SubString(spos,i-spos); spos=i; delimeterfound=true; break;}
   if(!delimeterfound){s1=s.SubString(spos,slength-spos+1);spos=slength; if(s1==NULL) break;}
   spos++;

   if(s1.Pos("OPERA de ")>0)
   {//    
    AnsiString s2;
    int pos136=s1.Pos(" 136.0#");
    if(pos136<1) continue; //    

    int pos_decall_1=s1.Pos("OPERA de ")+9; // 
    int pos_decall_2=s1.Pos(": 136.0#"); //  
    AnsiString decall=s1.SubString(pos_decall_1,pos_decall_2-pos_decall_1); //callsign    -
    decall.Trim();

    s2=s1.SubString(pos_decall_2+8,20);
    int len2=s2.Pos("#");
    AnsiString callto=s1.SubString(pos_decall_2+8,len2-1); //  -  
    callto.Trim();

    int pos_rep=s1.Pos("#SWL-Op32");
    if(pos_rep>0) //  ,      
    {
     AnsiString report;
     report=s1.SubString(pos_rep+10,s1.Length()-pos_rep-10+1);
     for(int i=1; i<=report.Length(); i++)// if(report.IsDelimiter("\n\r\a",i)) report.Delete(i,1);
     {AnsiString rr=report.SubString(i,1);
      unsigned char rc[3]; strncpy(rc,rr.c_str(),2);
      if(rc[0]<0x20) {report=report.SubString(1,i-1);break;}
     }
     report.Trim();
     // F:200%  Deep Search
     int pos_ds=report.Pos("F:200%");
     if(pos_ds>0) {report.Delete(pos_ds,6); report.Insert("Deep Search",pos_ds);}

     time_t t=time(NULL);
     struct tm *t_cur;
      t_cur=gmtime(&t);
     AnsiString fstr;
     fstr.sprintf("%02u:%02u:%02u   %s de %s Op32 %s",t_cur->tm_hour,t_cur->tm_min,t_cur->tm_sec,callto,decall,report);
     if(decall==mycall)
       fstr.sprintf("%02u:%02u:%02u   %s de %s Op32 %s",t_cur->tm_hour,t_cur->tm_min,t_cur->tm_sec,callto,decall,report);
    if(Form3->Visible) RichEdit1->SetFocus();
    if(reverse_output) RichEdit1->Lines->Insert(0,fstr);
    else RichEdit1->Lines->Add(fstr);
    int FoundAt=RichEdit1->FindText(fstr,0,RichEdit1->Text.Length(),TSearchTypes()<< stMatchCase);
    RichEdit1->SelStart=FoundAt; RichEdit1->SelLength=fstr.Length();
    RichEdit1->SelAttributes->Color=clNavy;
    if(pos_ds>0) RichEdit1->SelAttributes->Color=clGreen;
    if(callto==mycall) RichEdit1->SelAttributes->Color=clRed;
    if(decall==mycall) RichEdit1->SelAttributes->Color=clBlue;
    RichEdit1->SelStart=0; RichEdit1->SelLength=0;
    }
    else
    { //   
     AnsiString msg;
     int s1len=s1.Length();
     AnsiString scall= "#"+callto+"#";
     int pos_msg=s1.Pos(scall) + scall.Length();
     msg=s1.SubString(pos_msg,s1len-pos_msg+1);
     msg.Trim();
     time_t t=time(NULL);
     struct tm *t_cur;
      t_cur=gmtime(&t);
     AnsiString fstr;
     if(callto=="ALL" || decall==mycall)
     { fstr.sprintf("%02u:%02u %s > %s",t_cur->tm_hour,t_cur->tm_min,decall,msg);
       if(Form3->Visible)RichEdit2->SetFocus();
        if(reverse_output) RichEdit2->Lines->Insert(0,fstr);
        else RichEdit2->Lines->Add(fstr);
        int FoundAt=RichEdit2->FindText(fstr,0,RichEdit2->Text.Length(),TSearchTypes()<< stMatchCase);
        RichEdit2->SelStart=FoundAt; RichEdit2->SelLength=fstr.Length();
        RichEdit2->SelAttributes->Color=clBlack;
        RichEdit2->SelStart=0; RichEdit2->SelLength=0;
     }
     if(callto==mycall)
     {fstr.sprintf("%02u:%02u %s de %s > %s",t_cur->tm_hour,t_cur->tm_min,callto, decall,msg);
      if(Form3->Visible)RichEdit2->SetFocus();
      if(reverse_output) RichEdit2->Lines->Insert(0,fstr);
      else RichEdit2->Lines->Add(fstr);
      int FoundAt=RichEdit1->FindText(fstr,0,RichEdit2->Text.Length(),TSearchTypes()<< stMatchCase);
        RichEdit2->SelStart=FoundAt; RichEdit2->SelLength=fstr.Length();
        RichEdit2->SelAttributes->Color=clRed;
        RichEdit2->SelStart=0; RichEdit2->SelLength=0;
      AnsiString caption1="Message from "+decall;
      //MessageBox(NULL,msg.c_str(),caption1.c_str(),MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
      Edit1->Text=decall;
     }
    }
   }
  }
}
//---------------------------------------------------------------------------


void TForm3::sendOperaSpot(AnsiString call, AnsiString mycall, AnsiString report, AnsiString qth, float db, int km, int fad, float freq)
{
 bool flag=0;
 AnsiString s, s1,sfreq;
 sfreq.sprintf("%.1f",freq);
 s="CHAT OPERA 136.0#"+call+"##SWL-Op32  "+report+" "+mycity+" + "+myant+" "+sfreq+" Hz";
 s1=" ";

  try{
     if(!ClientSocket1->Active || need_reconnect)
     {
      ClientSocket1->Open();
      if(ClientSocket1->Active)ClientSocket1->Socket->SendText(mycall+"\n");
      if(ClientSocket1->Active)ClientSocket1->Socket->SendText("JOIN OPERA\n");
     }
     if(ClientSocket1->Active){ClientSocket1->Socket->SendText(s+"\n"); flag=true;}
     if(ClientSocket1->Active && Memo1->Lines->Count>0)
     {time_t tt=time(NULL);
      if(tt-tnotsend<600)ClientSocket1->Socket->SendText(Memo1->Lines->Text);
      Memo1->Lines->Text="";
     }
     need_reconnect=false;
    }catch(...){need_reconnect=true;}
   if(!flag) {
      tnotsend=time(NULL);
      struct tm *t_cur; t_cur=gmtime(&tnotsend);
      AnsiString tstr;
      tstr.sprintf(" (%02u:%02u:%02u)\n",t_cur->tm_hour,t_cur->tm_min,t_cur->tm_sec);
      Memo1->Lines->Add(s+tstr);
             }

 //ABCDEFGHIIndicativoRelacionSN0000005008##ABCDEFGHIIndicativoRelacionSN0000011004##RN3AUS                                      84-70=14                    84=+4 db   70=-3 dB
 //ABCDEFGHIIndicativoRelacionSN0000159003##RN3AUS-2##RN3AUS##KO85SP##KO85FN##136000##Op32_||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||_4dB##v1.5.8##3,55963##
 // 1 dB = ||
// s="ABCDEFGHIIndicativoRelacionSN0000146003##"+mycall+"##"+call+"##"+myqth+"##"+qth+"##136000##Op32_||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||_~"+db+"dB##v1.5.8##-3,243362##";
 AnsiString smeter, signdb;
 if(db<0)signdb="_~"; else signdb="_";
 int idb=floor(76 + 2*db);
 if(idb<=0)idb=1;
 if(fad>=100) smeter=smeter+"deepsearch";
 else for(int i=0; i<idb;i++)smeter=smeter+"/";

// s1.sprintf("ABCDEFGHIIndicativoRelacionSN0000159003##%s##%s##%s##%s##136000##Op32_%s%s%.0fdB##v1.5.8##%.6f##",mycall,call,myqth,qth,smeter,signdb,fabs(db),db);
 //ABCDEFGHIIndicativoRelacionSN0000103007##OPERA de RN3AUS-2: 136.0#RN3AUS##SWL-Op32 69 km F:10% +4 dB in Moscow 1500,0 Hz with 0w + MiniWhip
// s2.sprintf("ABCDEFGHIIndicativoRelacionSN0000103007##OPERA de %s: 136.0#%s##SWL-Op32 %d km F:%d%% %+.0f dB in %s %.1f Hz + %s",mycall,call,km,fad,db,mycity,freq,myant);

//      
AnsiString qth2="AA";
if(qth!="" && qth!=" ")qth2=qth.UpperCase();
//REPORTER##DX TO SPOT##REPORTER LOCATOR## DX LOCATOR## FREQ IN HZ WITHOUT PADDING##MODE OR INFO ABOUT REPORTER##DECODER VERSION##SIGNAL in DB##
//R3D-262##EA5DOM##KO94KS##IM98WN##136000##Op32__~43dB##v1.6.5##-43,23931##
//R3D-262##EA5DOM##KO94KS##AA##136000##Op32__~43dB##v1.6.5##-43,23931##

s1.sprintf("%s %s %s %s %.1f Op32_%s%s%.0fdB %.1f",mycall,call,myqth,qth2,freq,smeter,signdb,fabs(db),db);
/////////////////////////
///         curl
/////////////////////////
  AnsiString runstr=DataBaseExecStr + " " +s1;
  int result=WinExec(runstr.c_str(),SW_SHOWMINNOACTIVE);
  if(result>31)StatusBar1->SimpleText=call+" --> DB";
  else{  StatusBar1->SimpleText="Spot not sended to DB!";
   //   -    
   Memo2->Lines->Text="";
   Memo2->Lines->Add(s1);
   tnotsend=time(NULL);
  }
}

//---------------------------------------------------------------------------


void __fastcall TForm3::SelectAll1Click(TObject *Sender)
{
 RichEdit1->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::CopytoClipboard1Click(TObject *Sender)
{
 RichEdit1->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::EraseAll1Click(TObject *Sender)
{
 RichEdit1->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Select1Click(TObject *Sender)
{
 RichEdit2->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::CopytoClipboard2Click(TObject *Sender)
{
  RichEdit2->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::EraseAll2Click(TObject *Sender)
{
 RichEdit2->Clear();
}
//---------------------------------------------------------------------------


void __fastcall TForm3::CheckBox2Click(TObject *Sender)
{
 if(CheckBox2->Checked != Form1->UploadSpotstoOPERAcluster1->Checked)
  Form1->UploadSpotstoOPERAcluster1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Selectlogfile1Click(TObject *Sender)
{
 SaveDialog1->Execute();
 if(SaveDialog1->FileName==NULL) return;
 LogFileName=SaveDialog1->FileName;
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
 ini->WriteString("OPERA_CHAT","LOG_FILE_NAME",LogFileName);
 delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm3::SaveOperaSpotstologfile1Click(TObject *Sender)
{
 if(SaveOperaSpotstologfile1->Checked)SaveOperaSpotstologfile1->Checked=false;
 else SaveOperaSpotstologfile1->Checked=true;
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
 ini->WriteBool("OPERA_CHAT","LOG_ENABLE",SaveOperaSpotstologfile1->Checked);
 delete ini;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm3::HelpRus1Click(TObject *Sender)
{
 AnsiString s;
 s=" OPERA CHAT     .\n";
 s=s+"     Connect\n";
 s=s+"      Upload\n";
 s=s+"\n  ,    (Send to ALL)\n";
 s=s+" - ,       Call (Send PRIVATE).\n";
 s=s+"\n     -: File->Save Opera Spots to log-file\n";
 s=s+" -    File->Select log-file...\n";
 MessageBox(NULL,s.c_str(),"Op32Rx Chat Help",MB_OK|MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

void __fastcall TForm3::FontBold1Click(TObject *Sender)
{
 if(FontBold1->Checked) FontBold1->Checked=false;
 else FontBold1->Checked=true;
 if(FontBold1->Checked) RichEdit1->Font->Style= TFontStyles()<< fsBold;
 else  RichEdit1->Font->Style= TFontStyles();

}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm3::RichEdit1Change(TObject *Sender)
{
   if(SaveOperaSpotstologfile1->Checked) RichEdit1->Lines->SaveToFile(LogFileName);
}
//---------------------------------------------------------------------------


void __fastcall TForm3::SendspottoDataBase1Click(TObject *Sender)
{
 SaveDialog2->Execute();
 if(SaveDialog2->FileName==NULL) return;
 DataBaseExecStr=SaveDialog2->FileName;
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
 ini->WriteString("OPERA_DATABASE","EXEC_STRING",DataBaseExecStr);
 delete ini;
}
//---------------------------------------------------------------------------


